System [00 00 00 00 00 00 00 00 04 00 00 00 00 00 00 00] 1.0.3300.0 1.0.5000.0 2.0.0.0 4.0.0.0 Gtk# is thread aware, but not thread safe; See the <link location="node:gtk-sharp/programming/threads">Gtk# Thread Programming</link> for details. System.Object

The .NET Framework provides two ways to access metadata on a type: the reflection API provided in the namespace, and the class. Reflection is a general mechanism available to all types because its foundation is established in the method of the root class. The information it returns for a type is not extensible, in that it cannot be modified after compilation of the target type. For more information, see the topics in Reflection.

In contrast, is an extensible inspection mechanism for components: those classes that implement the interface. Unlike reflection, it does not inspect for methods. can be dynamically extended by several services available through the target component's . The following table shows these services.

Service name

Description

Enables another class, such as , to provide extra properties to a component.

Enables another object to modify the standard metadata that is exposed by a component.

Enables a class to completely and dynamically specify its own metadata, replacing the standard inspection mechanism of .

The extensibility provided by allows the design-time representation of a component to differ from its actual run-time representation, which makes useful for building design-time infrastructure.

All the methods in are static. You cannot create an instance of this class, and this class cannot be inherited.

You can set property and event values two different ways: specify them in the component class or change them at design time. Because you can set these values two ways, the overloaded methods of take two different types of parameters: a class type or an object instance.

When you want to access information and you have an instance of the object, use the method that calls for a component. Use the method that calls for the class type only when you do not have an instance of the object.

Properties and events are cached by for speed. Typically, they are constant for the lifetime of an object. However, extender providers and designers can change the set of properties on an object. If this is the case, then the method must be called to update the cache.

Provides information about the characteristics for a component, such as its attributes, properties, and events. This class cannot be inherited.

- Method
  2.0.0.0
  4.0.0.0
  System.ComponentModel.EditorBrowsable(System.ComponentModel.EditorBrowsableState.Advanced)
  System.ComponentModel.TypeDescriptionProvider `` `System.ParamArray`

  The method adds class-level attributes to the specified instance of a component. Because this is a common requirement of applications using the vsprvs Windows Forms Designer and Properties window, this method provides a shortcut by creating a type description provider that merges the provided attributes with the attributes that already exist on the class. The return value is the type description provider that was used to add the attributes. This provider can later be passed to the method when the added attributes are no longer needed.

  Adds class-level attributes to the target component instance.

  The newly created that was used to add the specified attributes.

  An instance of the target component. An array of objects to add to the component's class.
- Method
  2.0.0.0
  4.0.0.0
  System.ComponentModel.EditorBrowsable(System.ComponentModel.EditorBrowsableState.Advanced)
  System.ComponentModel.TypeDescriptionProvider `` `System.ParamArray`

  The method adds class-level attributes to the specified type of a component. Because this is a common requirement of applications using the vsprvs Windows Forms Designer and Properties window, this method provides a shortcut by creating a type description provider that merges the provided attributes with the attributes that already exist on the class. The return value is the type description provider that was used to add the attributes. This provider can later be passed to the method when the added attributes are no longer needed.

  Adds class-level attributes to the target component type.

  The newly created that was used to add the specified attributes.

  The of the target component. An array of objects to add to the component's class.
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.ComponentModel.EditorBrowsable(System.ComponentModel.EditorBrowsableState.Advanced)
  System.Void `` ``

  The method adds an editor table for the given editor base type. Typically, editors are specified as metadata on a component. However, if no metadata for a requested editor base type can be found on the component, the associated will search an editor table for the editor type, if one can be found. Once an editor table has been added to a type descriptor, it cannot be removed and is owned by the type descriptor. The type descriptor may freely make modifications to this table.

  The format for an editor table uses data types as keys and editors as values. The value portion of an entry in the table represents an editor instance. It can have one of three values. If it contains a string, the type descriptor will assume this is a fully qualified name of a type, and then load the type for the object. If it contains a type, an instance of this type will be created to obtain an editor. Finally, the value portion may contain an actual editor instance. If the type descriptor resolves an editor to an instance, it will store the instance back into the table for future use.

  Adds an editor table for the given editor base type.

  The editor base type to add the editor table for. If a table already exists for this type, this method will do nothing. The to add.
- Method
  2.0.0.0
  4.0.0.0
  System.ComponentModel.EditorBrowsable(System.ComponentModel.EditorBrowsableState.Advanced)
  System.Void `` ``

  The method adds a type description provider that supplies type information for a single instance of a component. If a provider is added by this method, the provider's method will not be called because the instance already exists.

  This method does not maintain a hard reference to the component, so it does not prevent the component from finalizing.

  It is possible to add multiple type description providers for the same type or object. If this occurs, the first type description provider encountered that provides type information will be used exclusively. Since type information providers are stored in a stack, the last provider added will be the first one queried. This behavior enables the and methods to be used to push and pop type description providers as required for particular scenarios.

  If successful, this method calls the method on the parameter.

  The two versions of this method produce results with different scopes. The method that takes an parameter affects only that single instance of the component specified. In contrast, the other overload, which takes a parameter, affects all instances of the component described by that type.

  Use the method if you need to call from partially trusted code.

  Adds a type description provider for a single instance of a component.

  The to add. An instance of the target component.
- Method
  2.0.0.0
  4.0.0.0
  System.ComponentModel.EditorBrowsable(System.ComponentModel.EditorBrowsableState.Advanced)
  System.Void `` ``

  The method adds a type description provider that supplies type information for the specified class, derived classes, and all instances of these types.

  The parameter can be any type, including an interface. For example, to provide custom type and instance information for all components, you would specify typeof(IComponent). Passing typeof(object) will call the provider to supply type information for all types.

  This method does not maintain a hard reference to any object, so it does not prevent objects from finalizing.

  It is possible to add multiple type description providers for the same type or object. If this occurs, the first type description provider encountered that provides type information will be used exclusively. Because type information providers are stored in a stack, the last provider added will be the first one queried. This behavior enables the and methods to be used to push and pop type description providers as required for particular scenarios.

  If successful, this method calls the method on the parameter.

  The two versions of this method produce results with different scopes. The method that takes an parameter affects only that single instance of the component specified. In contrast, the other overload, which takes a parameter, affects all instances of the component described by that type.

  Use the method if you need to call from partially trusted code.

  Adds a type description provider for a component class.

  The to add. The of the target component.
- Method
  4.0.0.0
  System.ComponentModel.EditorBrowsable(System.ComponentModel.EditorBrowsableState.Advanced)
  System.MonoLimitation("Security not applied.")
  System.Void `` ``

  This method can be called from partially trusted code. If is defined, the caller can register a provider for the specified instance if its type is also partially trusted.

  Use the method if you do not need to call from partially trusted code.

  Adds a type description provider for a single instance of a component.

  The to add. An instance of the target component.
- Method
  4.0.0.0
  System.ComponentModel.EditorBrowsable(System.ComponentModel.EditorBrowsableState.Advanced)
  System.MonoLimitation("Security not applied.")
  System.Void `` ``

  This method can be called from partially trusted code. If is defined, the caller can register a provider for the specified type if it is also partially trusted.

  Use the method if you do not need to call from partially trusted code.

  Adds a type description provider for a component class.

  The to add. The of the target component.
- Property
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Obsolete("Use ComObjectType")
  System.ComponentModel.IComNativeDescriptorHandler To be added: an object of type 'IComNativeDescriptorHandler'

  The property and the interface are obsolete. For more information, see the property.

  Gets or sets the provider for the Component Object Model (COM) type information for the target component.

- Property
  2.0.0.0
  4.0.0.0
  System.ComponentModel.EditorBrowsable(System.ComponentModel.EditorBrowsableState.Advanced)
  System.MonoNotSupported("Mono does not support COM")
  System.Type To be added.

  The property returns a type that can be passed to the method to define a type description provider for COM types.

  The property and other members in this class replace the functionality in the obsolete interface. To implement a mapping layer between a COM object and , add a to handle type .

  Gets the type of the Component Object Model (COM) object represented by the target component.

- Method
  2.0.0.0
  4.0.0.0
  System.ComponentModel.EditorBrowsable(System.ComponentModel.EditorBrowsableState.Advanced)
  System.MonoNotSupported("Associations not supported")
  System.Void `` ``

  The method creates an association between a primary and a secondary object. Once an association is created, a designer or other filtering mechanism can add properties that route to either object into the primary object's property set. When a property invocation is made against the primary object, the method will be called to resolve the actual object instance that is related to its type parameter.

  A is used to maintain the association between the primary and secondary object; therefore, this method does not prevent either object from being finalized and reclaimed by garbage collection.

  Creates a primary-secondary association between two objects.

  The primary . The secondary .
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.ComponentModel.Design.IDesigner `` ``

  If this method cannot find a valid , it searches up the class hierarchy for a designer. If it cannot find a designer in the class hierarchy, it returns null.

  Creates an instance of the designer associated with the specified component and of the specified type of designer.

  An that is an instance of the designer for the component, or null if no designer can be found.

  An that specifies the component to associate with the designer. A that represents the type of designer to create.
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.ComponentModel.EventDescriptor `` `` `System.ParamArray` To be added

  Creates a new event descriptor that is identical to an existing event descriptor, when passed the existing .

  A new that has merged the specified metadata attributes with the existing metadata attributes.

  The type of the component for which to create the new event. The existing event information. The new attributes.
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.ComponentModel.EventDescriptor `` `` `` `System.ParamArray` To be added

  Creates a new event descriptor that is identical to an existing event descriptor by dynamically generating descriptor information from a specified event on a type.

  An that is bound to a type.

  The type of the component the event lives on. The name of the event. The type of the delegate that handles the event. The attributes for this event.
- Method
  2.0.0.0
  4.0.0.0
  System.MonoTODO
  System.Object `` `` `` ``

  The method will search for a that is associated with the specified data type. This method first tries to obtain a type description provider from the parameter. If this fails, it searches its own internal tables for a provider (these entries were created through previous calls to ). If it finds a provider, this method will delegate the creation call to that object.

  Creates an object that can substitute for another data type.

  An instance of the substitute data type if an associated is found; otherwise, null.

  The service provider that provides a service. This parameter can be null. The of object to create. An optional array of parameter types to be passed to the object's constructor. This parameter can be null or an array of zero length. An optional array of parameter values to pass to the object's constructor. If not null, the number of elements must be the same as .
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.ComponentModel.PropertyDescriptor `` `` `System.ParamArray` To be added

  Creates a new property descriptor from an existing property descriptor, using the specified existing and attribute array.

  A new that has the specified metadata attributes merged with the existing metadata attributes.

  The of the component that the property is a member of. The existing property descriptor. The new attributes for this property.
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.ComponentModel.PropertyDescriptor `` `` `` `System.ParamArray` To be added

  Creates and dynamically binds a property descriptor to a type, using the specified property name, type, and attribute array.

  A that is bound to the specified type and that has the specified metadata attributes merged with the existing metadata attributes.

  The of the component that the property is a member of. The name of the property. The of the property. The new attributes for this property.
- Method
  2.0.0.0
  4.0.0.0
  System.ComponentModel.EditorBrowsable(System.ComponentModel.EditorBrowsableState.Advanced)
  System.MonoNotSupported("Associations not supported")
  System.Object `` ``

  If a previous association has been made for the parameter using the method, then the method returns the correct secondary object to invoke for the requested type. Otherwise, searches for a compatible designer for and returns the designer if one is found. This method never returns null.

  A is used to maintain the association between the primary and secondary object; therefore, this method does not prevent either the primary or secondary object from being finalized and reclaimed by garbage collection.

  Returns an instance of the type associated with the specified primary object.

  An instance of the secondary type that has been associated with the primary object if an association exists; otherwise, if no specified association exists.

  The of the target component. The primary object of the association.
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.ComponentModel.AttributeCollection ``

  The attributes returned by the method may be dynamically modified from the original component's source listing by extender providers (), filter services (), and attribute filters.

  When you define a custom attribute with set to true, you must override the property to make it unique. If all instances of your attribute are unique, override to return the object identity of your attribute. If only some instances of your attribute are unique, return a value from that would return equality in those cases. For example, some attributes have a constructor parameter that acts as a unique key. For these attributes, return the value of the constructor parameter from the property.

  The default implementation of returns the type identity regardless of the value of the property. In order to return multiple instances of an attribute from the , your attribute must override the property.

  Returns the collection of attributes for the specified component.

  An containing the attributes for the component. If is null, this method returns an empty collection.

  The component for which you want to get attributes.
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.ComponentModel.AttributeCollection ``

  Call this version of this method only when you do not have an instance of the object.

  For attributes with set to true, the attribute collection removes duplicate instances. These are instances in which the property returns equal values.

  When you define a custom attribute with set to true, you must override the property to make it unique. If all instances of your attribute are unique, override to return the object identity of your attribute. If only some instances of your attribute are unique, return a value from that would return equality in those cases. For example, some attributes have a constructor parameter that acts as a unique key. For these attributes, return the value of the constructor parameter from the property.

  The default implementation of returns the type identity regardless of the value of the property. In order to return multiple instances of an attribute from the , your attribute must override the property.

  Returns a collection of attributes for the specified type of component.

  An with the attributes for the type of the component. If the component is null, this method returns an empty collection.

  The of the target component.
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.ComponentModel.EditorBrowsable(System.ComponentModel.EditorBrowsableState.Advanced)
  System.ComponentModel.AttributeCollection `` ``

  The attributes returned by the method may be dynamically modified from the original components source listing by extender providers (), filter services (), and attribute filters.

  When you define a custom attribute with set to true, you must override the property to make it unique. If all instances of your attribute are unique, override to return the object identity of your attribute. If only some instances of your attribute are unique, return a value from that would return equality in those cases. For example, some attributes have a constructor parameter that acts as a unique key. For these attributes, return the value of the constructor parameter from the property.

  The default implementation of returns the type identity regardless of the value of the property. In order to return multiple instances of an attribute from the , your attribute must override the property.

  Returns a collection of attributes for the specified component and a Boolean indicating that a custom type descriptor has been created.

  An with the attributes for the component. If the component is null, this method returns an empty collection.

  The component for which you want to get attributes. true to use a baseline set of attributes from the custom type descriptor if is of type ; otherwise, false.
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.String ``

  Typically, this method returns the full name for the parameter type. For example, the class name for a button is "System.Windows.Forms.Button". If implements , it can return an alternate name.

  This method is equivalent to the overloaded method with a second parameter of false.

  Returns the name of the class for the specified component using the default type descriptor.

  A containing the name of the class for the specified component.

  The for which you want the class name.
- Method
  2.0.0.0
  4.0.0.0
  System.MonoNotSupported("")
  System.String ``

  This method uses the cached custom type descriptor for the specified type to discover the associated class name.

  Returns the name of the class for the specified type.

  A containing the name of the class for the specified component type.

  The of the target component.
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.ComponentModel.EditorBrowsable(System.ComponentModel.EditorBrowsableState.Advanced)
  System.String `` ``

  Typically, this method returns the full name for the parameter type. For example, the class name for a button is "System.Windows.Forms.Button". If the parameter implements , it can return an alternate name.

  Returns the name of the class for the specified component using a custom type descriptor.

  A containing the name of the class for the specified component.

  The for which you want the class name. true to consider custom type description information; otherwise, false.
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.String ``

  Typically, this method returns the name for the site of the component, if one exists. For example, the class name for a button is "System.Windows.Forms.Button".

  This method is equivalent to the overloaded method with a second parameter of false.

  This method is used at design time to retrieve the name of an instance of a component.

  Returns the name of the specified component using the default type descriptor.

  A containing the name of the specified component, or null if there is no component name.

  The for which you want the class name.
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.ComponentModel.EditorBrowsable(System.ComponentModel.EditorBrowsableState.Advanced)
  System.String `` ``

  This method is used at design time to retrieve the name of an instance of a component. Typically, this method returns the name for the site of the component, if one exists. For example, the class name for a button is "System.Windows.Forms.Button". If the component implements the interface, it can return an alternate name.

  Returns the name of the specified component using a custom type descriptor.

  The name of the class for the specified component, or null if there is no component name.

  The for which you want the class name. true to consider custom type description information; otherwise, false.
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.ComponentModel.TypeConverter ``

  This method locates an appropriate type converter by looking for a . If it cannot find a , it traverses the base class hierarchy of the class until it finds a primitive type.

  This method is equivalent to the overloaded method with a second parameter of false.

  Returns a type converter for the type of the specified component.

  A for the specified component.

  A component to get the converter for.
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.ComponentModel.TypeConverter ``

  Call this version of this method only when you do not have an instance of the object.

  This method looks for the appropriate type converter by looking for a . If it cannot find a , it traverses the base class hierarchy of the class until it finds a primitive type.

  Returns a type converter for the specified type.

  A for the specified type.

  The of the target component.
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.ComponentModel.EditorBrowsable(System.ComponentModel.EditorBrowsableState.Advanced)
  System.ComponentModel.TypeConverter `` ``

  This method looks for the appropriate type converter by trying to find a . If it cannot find a , it traverses the base class hierarchy of the class until it finds a primitive type.

  Returns a type converter for the type of the specified component with a custom type descriptor.

  A for the specified component.

  A component to get the converter for. true to consider custom type description information; otherwise, false.
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.ComponentModel.EventDescriptor ``

  This method is equivalent to the overloaded method with a second parameter of false.

  Returns the default event for the specified component.

  An with the default event, or null if there are no events.

  The component to get the event for.
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.ComponentModel.EventDescriptor ``

  Call this version of this method only when you do not have an instance of the object.

  Returns the default event for the specified type of component.

  An with the default event, or null if there are no events.

  The of the target component.
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.ComponentModel.EditorBrowsable(System.ComponentModel.EditorBrowsableState.Advanced)
  System.ComponentModel.EventDescriptor `` `` To be added

  Returns the default event for a component with a custom type descriptor.

  An with the default event, or null if there are no events.

  The component to get the event for. true to consider custom type description information; otherwise, false.
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.ComponentModel.PropertyDescriptor ``

  If the parameter is null, this method returns null.

  Returns the default property for the specified component.

  A with the default property, or null if there are no properties.

  The component to get the default property for.
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.ComponentModel.PropertyDescriptor ``

  Call this version of this method only when you do not have an instance of the object.

  If the parameter is null, this method returns null.

  Returns the default property for the specified type of component.

  A with the default property, or null if there are no properties.

  A that represents the class to get the property for.
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.ComponentModel.EditorBrowsable(System.ComponentModel.EditorBrowsableState.Advanced)
  System.ComponentModel.PropertyDescriptor `` ``

  If the parameter is null, this method returns null.

  Returns the default property for the specified component with a custom type descriptor.

  A with the default property, or null if there are no properties.

  The component to get the default property for. true to consider custom type description information; otherwise, false.
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Object `` ``

  The type of is usually , but you can also use other types (for example, and ).

  You can define multiple editors for a property. You use this method to select the editor you want to use.

  Gets an editor with the specified base type for the specified component.

  An instance of the editor that can be cast to the specified editor type, or null if no editor of the requested type can be found.

  The component to get the editor for. A that represents the base type of the editor you want to find.
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Object `` `` To be added.

  The type of is usually , but you can also use other types (for example and ).

  You can define multiple editors for a type. You use this method to select the one you want to use.

  Call this version of this method only when you do not have an instance of the object.

  Returns an editor with the specified base type for the specified type.

  An instance of the editor object that can be cast to the given base type, or null if no editor of the requested type can be found.

  A that represents the base type of the editor you are trying to find.
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.ComponentModel.EditorBrowsable(System.ComponentModel.EditorBrowsableState.Advanced)
  System.Object `` `` ``

  The type of is usually , but you can also use other types (for example and ).

  You can define multiple editors for a property. You use this method to select the editor you want to use.

  Returns an editor with the specified base type and with a custom type descriptor for the specified component.

  An instance of the editor that can be cast to the specified editor type, or null if no editor of the requested type can be found.

  The component to get the editor for. A that represents the base type of the editor you want to find. A flag indicating whether custom type description information should be considered.
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.ComponentModel.EventDescriptorCollection ``

  Retrieves a collection of events that the given parameter instance provides. This collection can differ from the set of events the class provides. If the parameter is sited, the site can add or remove additional events.

  If is null, then an empty collection is returned.

  The order of the returned collection is not guaranteed to be identical between calls, so always order it before use.

  Returns the collection of events for the specified component.

  An with the events for this component.

  A component to get the events for.
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.ComponentModel.EventDescriptorCollection ``

  Call this version of this method only when you do not have an instance of the object.

  If the parameter is null, an empty collection is returned.

  The order of the returned collection is not guaranteed to be identical between calls, so always order it before use.

  Returns the collection of events for a specified type of component.

  An with the events for this component.

  The of the target component.
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.ComponentModel.EventDescriptorCollection `` ``

  The events for the parameter can differ from the events of a class, because the site can add or remove events if the parameter is sited.

  The array can have a mix of and objects. Filtering is defined by the following rules:

  A is treated as a wildcard; it matches any event that has the in its set of attributes.

  If an event does not have an of the same class, the event is not included in the returned array.

  If the attribute is an instance of the class, the event must be an exact match or it is not included in the returned array.

  If an instance is specified and it is the default event, it is included in the returned array even if there is no instance of the in the event.

  If is null, an empty collection is returned.

  The order of the returned collection is not guaranteed to be identical between calls, so always order it before use.

  Returns the collection of events for a specified component using a specified array of attributes as a filter.

  An with the events that match the specified attributes for this component.

  A component to get the events for. An array of type that you can use as a filter.
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.ComponentModel.EditorBrowsable(System.ComponentModel.EditorBrowsableState.Advanced)
  System.ComponentModel.EventDescriptorCollection `` ``

  This method retrieves a collection of events that the given parameter instance provides. This can differ from the set of events the class provides. If the parameter is sited, the site can add or remove additional events.

  If is null, an empty collection is returned.

  The order of the returned collection is not guaranteed to be identical between calls, so always order it before use.

  Returns the collection of events for a specified component with a custom type descriptor.

  An with the events for this component.

  A component to get the events for. true to consider custom type description information; otherwise, false.
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.ComponentModel.EventDescriptorCollection `` ``

  Call this version of this method only when you do not have an instance of the object.

  The parameter array can have a mix of and objects. Filtering is defined by the following rules:

  A is treated as a wildcard; it matches any event that has the in its set of attributes.

  If an event does not have an of the same class, the event is not included in the returned array.

  If the attribute is an instance of the class, the event must be an exact match or it is not included in the returned array.

  If an instance is specified and it is the default event, it is included in the returned array even if there is no instance of the in the event.

  If the parameter is null, an empty collection is returned.

  The order of the returned collection is not guaranteed to be identical between calls, so always order it before use.

  Returns the collection of events for a specified type of component using a specified array of attributes as a filter.

  An with the events that match the specified attributes for this component.

  The of the target component. An array of type that you can use as a filter.
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.ComponentModel.EditorBrowsable(System.ComponentModel.EditorBrowsableState.Advanced)
  System.ComponentModel.EventDescriptorCollection `` `` ``

  The events for the parameter can differ from the events of a class, because the site can add or remove events if the parameter is sited.

  The parameter array can have a mix of and objects. Filtering is defined by the following rules:

  A is treated as a wildcard; it matches any event that has the in its set of attributes.

  If an event does not have an of the same class, the event is not included in the returned array.

  If the attribute is an instance of the class, the event must be an exact match or it is not included in the returned array.

  If an instance is specified and it is the default event, it is included in the returned array even if there is no instance of the in the event.

  If is null, an empty collection is returned.

  The order of the returned collection is not guaranteed to be identical between calls, so always order it before use.

  Returns the collection of events for a specified component using a specified array of attributes as a filter and using a custom type descriptor.

  An with the events that match the specified attributes for this component.

  A component to get the events for. An array of type to use as a filter. true to consider custom type description information; otherwise, false.
- Method
  2.0.0.0
  4.0.0.0
  System.MonoNotSupported("")
  System.String ``

  In many cases, the method will return the same value as the method. However, if the component resides in a nested container or has other nested semantics, it may return a different fully qualified name.

  Returns the fully qualified name of the component.

  The fully qualified name of the specified component, or null if the component has no name.

  The to find the name for.
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.ComponentModel.PropertyDescriptorCollection ``

  The properties for a component can differ from the properties of a class, because the site can add or remove properties if the component is sited.

  If the parameter is null, an empty collection is returned.

  The order of the returned collection is not guaranteed to be identical between calls, so always order it before use.

  Returns the collection of properties for a specified component.

  A with the properties for the specified component.

  A component to get the properties for.
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.ComponentModel.PropertyDescriptorCollection ``

  Call this version of this method only when you do not have an instance of the object.

  If the parameter is null, an empty collection is returned.

  The order of the returned collection is not guaranteed to be identical between calls, so always order it before use.

  Returns the collection of properties for a specified type of component.

  A with the properties for a specified type of component.

  A that represents the component to get properties for.
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.ComponentModel.PropertyDescriptorCollection `` ``

  The properties for the parameter can differ from the properties of a class, because the site can add or remove properties if the parameter is sited.

  The parameter array is used to filter the array. Filtering is defined by the following rules:

  If a property does not have an of the same class, the property is not included in the returned array.

  If the attribute is an instance of the class, the property must be an exact match or it is not included in the returned array.

  If an instance is specified and it is the default property, it is included in the returned array even if there is no instance of the in the property.

  If has a default attribute, the method matches the case when the property does not have the attribute applied.

  If is null, an empty collection is returned.

  The order of the returned collection is not guaranteed to be identical between calls, so always order it before use.

  Returns the collection of properties for a specified component using a specified array of attributes as a filter.

  A with the properties that match the specified attributes for the specified component.

  A component to get the properties for. An array of type to use as a filter.
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.ComponentModel.EditorBrowsable(System.ComponentModel.EditorBrowsableState.Advanced)
  System.ComponentModel.PropertyDescriptorCollection `` ``

  The properties for the parameter can differ from the properties of a class, because the site can add or remove properties if the parameter is sited.

  If is null, an empty collection is returned.

  The order of the returned collection is not guaranteed to be identical between calls, so always order it before use.

  Returns the collection of properties for a specified component using the default type descriptor.

  A with the properties for a specified component.

  A component to get the properties for. true to not consider custom type description information; otherwise, false.
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.ComponentModel.PropertyDescriptorCollection `` ``

  Call this version of this method only when you do not have an instance of the object.

  The parameter array is used to filter the array. Filtering is defined by the following rules:

  If a property does not have an of the same class, the property is not included in the returned array.

  If the attribute is an instance of the class, the property must be an exact match or it is not included in the returned array.

  If an instance is specified and it is the default property, it is included in the returned array even if there is no instance of the in the property.

  If has a default attribute, the method matches the case when the property does not have the attribute applied.

  If the parameter is null, an empty collection is returned.

  The order of the returned collection is not guaranteed to be identical between calls, so always order it before use.

  Returns the collection of properties for a specified type of component using a specified array of attributes as a filter.

  A with the properties that match the specified attributes for this type of component.

  The of the target component. An array of type to use as a filter.
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.ComponentModel.PropertyDescriptorCollection `` `` ``

  The properties for a can differ from the properties of a class, because the site can add or remove properties if the is sited.

  The parameter array is used to filter the array. Filtering is defined by the following rules:

  If a property does not have an of the same class, the property is not included in the returned array.

  If the attribute is an instance of the class, the property must be an exact match or it is not included in the returned array.

  If an instance is specified and it is the default property, it is included in the returned array even if there is no instance of the in the property.

  If has a default attribute, the method matches the case when the property does not have the attribute applied.

  If the parameter is null, an empty collection is returned.

  The order of the returned collection is not guaranteed to be identical between calls, so always order it before use.

  Returns the collection of properties for a specified component using a specified array of attributes as a filter and using a custom type descriptor.

  A with the events that match the specified attributes for the specified component.

  A component to get the properties for. An array of type to use as a filter. true to consider custom type description information; otherwise, false.
- Method
  2.0.0.0
  4.0.0.0
  System.ComponentModel.EditorBrowsable(System.ComponentModel.EditorBrowsableState.Advanced)
  System.ComponentModel.TypeDescriptionProvider ``

  The method will always return a type description provider. Even the default implementation is built on a .

  Returns the type description provider for the specified component.

  A associated with the specified component.

  An instance of the target component.
- Method
  2.0.0.0
  4.0.0.0
  System.ComponentModel.EditorBrowsable(System.ComponentModel.EditorBrowsableState.Advanced)
  System.ComponentModel.TypeDescriptionProvider ``

  The method will always return a type description provider. Even the default implementation is built on a .

  Returns the type description provider for the specified type.

  A associated with the specified type.

  The of the target component.
- Method
  2.0.0.0
  4.0.0.0
  System.ComponentModel.EditorBrowsable(System.ComponentModel.EditorBrowsableState.Advanced)
  System.Type ``

  The method is a low-level version of the method. is typically used to perform standard reflection against an object when no custom type descriptor can be located for it.

  Returns a that can be used to perform reflection, given an object.

  A for the specified object.

  An instance of the target component.
- Method
  2.0.0.0
  4.0.0.0
  System.ComponentModel.EditorBrowsable(System.ComponentModel.EditorBrowsableState.Advanced)
  System.Type ``

  The method is a low-level version of the method. is typically used to perform standard reflection against a class when no custom type descriptor can be located for it.

  Returns a that can be used to perform reflection, given a class type.

  A of the specified class.

  The of the target component.
- Property
  4.0.0.0
  System.ComponentModel.EditorBrowsable(System.ComponentModel.EditorBrowsableState.Advanced)
  System.Type To be added.

  The property gets a object that you can pass to the methods to define a type description provider for interface types.

  Gets a type that represents a type description provider for all interface types.

- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Void ``

  Properties and events are cached by for speed. Typically, they are constant for the lifetime of an object. However, extender providers and designers can change the set of properties on an object. If they do, they should call this method to clear the property and event descriptors of the object. This method is used only at design time. It is not used during run time.

  This method also raises a event when the properties or events of a component change. This event is only raised if there was a prior call to the or method that cached the information.

  Clears the properties and events for the specified component from the cache.

  A component for which the properties or events have changed.
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Void ``

  Properties and events are cached by for speed. Typically, they are constant for the lifetime of an object. However, extender providers and designers can change the set of properties on an object. If they do, they can call this method to clear the property and event descriptors of the object. This method is used only at design time. It is not used during run time.

  Before you make a call to the method to clear the cache, you need to call the method for the specific assembly to cache the information first.

  This method also raises a event to notify all classes that want to be notified when the property set of a component changes.

  Clears the properties and events for the specified assembly from the cache.

  The that represents the assembly to refresh. Each in this assembly will be refreshed.
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Void ``

  Properties and events are cached by for speed. Typically, they are constant for the lifetime of an object. However, extender providers and designers can change the set of properties on an object. If they do, they can call this method to clear the property and event descriptors of the object. This method is used only at design time. It is not used during run time.

  Before you make a call to the method to clear the cache, you need to call the method for the specific module to cache the information first.

  This method also raises a event to notify all classes that want to be notified when the property set of a component changes.

  Clears the properties and events for the specified module from the cache.

  The that represents the module to refresh. Each in this module will be refreshed.
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Void ``

  Call this version of this method only when you do not have an instance of the object.

  Properties and events are cached by for speed. Typically, they are constant for the lifetime of an object. However, extender providers and designers can change the set of properties on an object. If they do, they can call this method to clear the property and event descriptors of the object. This method is used only at design time. It is not used during run time.

  This method also raises a event when the properties or events of a component change. This event is only raised if there was a prior call to the or method that cached the information.

  Clears the properties and events for the specified type of component from the cache.

  The of the target component.
- Event
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.ComponentModel.RefreshEventHandler

  For more information about handling events, see Consuming Events.

  Occurs when the cache for a component is cleared.

- Method
  2.0.0.0
  4.0.0.0
  System.ComponentModel.EditorBrowsable(System.ComponentModel.EditorBrowsableState.Advanced)
  System.MonoNotSupported("Associations not supported")
  System.Void `` ``

  The method removes an association between two objects formed by the method.

  A is used to maintain the association between the primary and secondary object; therefore, this method does not influence when either object is finalized or reclaimed by garbage collection.

  Removes an association between two objects.

  The primary . The secondary .
- Method
  2.0.0.0
  4.0.0.0
  System.ComponentModel.EditorBrowsable(System.ComponentModel.EditorBrowsableState.Advanced)
  System.MonoNotSupported("Associations not supported")
  System.Void ``

  The method removes all associations between a primary object and all of its secondary objects, created by calls to the method.

  A is used to maintain the association between the primary and secondary object; therefore, this method does not influence when either the primary of secondary objects are finalized or reclaimed by garbage collection.

  Removes all associations for a primary object.

  The primary in an association.
- Method
  2.0.0.0
  4.0.0.0
  System.ComponentModel.EditorBrowsable(System.ComponentModel.EditorBrowsableState.Advanced)
  System.Void `` ``

  This method removes a type description provider previously added with the method. Removing a provider causes a event to be raised for the associated object.

  Use the method if you need to call from partially trusted code.

  Removes a previously added type description provider that is associated with the specified object.

  The to remove. An instance of the target component.
- Method
  2.0.0.0
  4.0.0.0
  System.ComponentModel.EditorBrowsable(System.ComponentModel.EditorBrowsableState.Advanced)
  System.Void `` ``

  This method removes a type description provider previously added with the method. Removing a provider causes a event to be raised for the associated type.

  Use the method if you need to call from partially trusted code.

  Removes a previously added type description provider that is associated with the specified type.

  The to remove. The of the target component.
- Method
  4.0.0.0
  System.ComponentModel.EditorBrowsable(System.ComponentModel.EditorBrowsableState.Advanced)
  System.MonoLimitation("Security not applied.")
  System.Void `` ``

  This method removes a type description provider previously added with the method. Removing a provider causes a event to be raised for the associated object.

  This method can be called from partially trusted code. If is defined, the caller can register a provider for the specified instance if its type is also partially trusted.

  Use the method if you do not need to call from partially trusted code.

  Removes a previously added type description provider that is associated with the specified object.

  The to remove. An instance of the target component.
- Method
  4.0.0.0
  System.ComponentModel.EditorBrowsable(System.ComponentModel.EditorBrowsableState.Advanced)
  System.MonoLimitation("Security not applied.")
  System.Void `` ``

  This method removes a type description provider previously added with the method. Removing a provider causes a event to be raised for the associated type.

  This method can be called from partially trusted code. If is defined, the caller can unregister a provider for the specified type if it is also partially trusted.

  Use the method if you do not need to call from partially trusted code.

  Removes a previously added type description provider that is associated with the specified type.

  The to remove. The of the target component.
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Void `` To be added

  Sorts descriptors using the name of the descriptor.

  An that contains the descriptors to sort.